unit ProfileDataset;

interface
uses
  DBClient;

type
  {This is the delphi interceptor pattern.
   Add this unit to the uses clause to make delphi use
   this class in favour of the usual one.
  }
  TClientDataset = class(DBClient.TClientDataset)
  public
    function DataRequest(Data: OleVariant): OleVariant; override;
  end;

{This is accurate to the ms, but is NT only.
This should be sufficient for most optimisation needs.}
function GetEnhancedTickCount : integer;

implementation
uses
  windows, SysUtils, Tracelib;

var
  performancefreq : TLargeinteger;

{ TClientDataset }

{
  Note GetTickCount is only accurate to 10ms.
  Here I use QueryPeformanceCounter
  but that is NT only.
}
function TClientDataset.DataRequest(Data: OleVariant): OleVariant;
var
  aFirst, aSecond : Longint;
begin
  aFirst := GetEnhancedTickCount;
  result := inherited DataRequest(Data);
  aSecond := GetEnhancedTickCount;
  Trace( Format('%s took %dms',[self.Name, aSecond-aFirst]) );
end;

function GetEnhancedTickCount : integer;
var
  a : TLargeInteger;
begin
  QueryPerformanceCounter(a);
  result := (1000 * a) div performancefreq;
end;

initialization
  QueryPerformanceFrequency(performancefreq);
end.
